// CameraViewerDlg.cpp : t@C
//
#include "stdafx.h"
#include "CameraViewer.h"
#include "CameraViewerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// ő剻̃AXyNgێ
// XN[Lv`

#define PATH_CONFIG_FILE "./config.txt"


void char_to_LPCWSTR( char src[], wchar_t dst[] )
{
	size_t origsize = strlen(src) + 1;
	size_t convertedChars = 0;
	mbstowcs_s(&convertedChars, dst, origsize, src, _TRUNCATE );
}


void cvuSetWindowFull(char win[])
{
	const int CVU_WIN_FULL_OFFSET_POS = -4;
	const int CVU_FULL_OFFSET_WIDTH = 7;
	const char CVU_WINDOW_CLASS[] = "Main HighGUI class";
 
	cvDestroyWindow(win);
	cvNamedWindow(win,0);
 
	int dispWidth = GetSystemMetrics(SM_CXSCREEN);		// ʉ𑜓x̎擾
	int dispHeight = GetSystemMetrics(SM_CYSCREEN);

	wchar_t win2[1024];
	char_to_LPCWSTR( win, win2 );
	HWND hWnd = FindWindow(TEXT("Main HighGUI class"), win2);		// EBhET
	// cvGetWindowHandle()ƂȂ܂Ȃ
 
	// EBhEX^C̕ύX
	SetWindowLong( hWnd, GWL_STYLE,WS_VISIBLE | WS_POPUP);
 
	// \ʒũZbgi_~[D킴ƈقȂݒj
	SetWindowPos( hWnd, HWND_TOP, 0, 0, dispWidth, dispHeight, SWP_SHOWWINDOW );
 
	// \ʒũZbgi{DȂƂ܂KpȂHj
	SetWindowPos( hWnd, HWND_TOP, CVU_WIN_FULL_OFFSET_POS, CVU_WIN_FULL_OFFSET_POS,
				  dispWidth + CVU_FULL_OFFSET_WIDTH, dispHeight + CVU_FULL_OFFSET_WIDTH,
				  SWP_SHOWWINDOW );
}

void cvuSetWindowNormal( const char *win, int flags=1 )
{
	cvDestroyWindow(win);
	cvNamedWindow(win,flags);
}




// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCameraViewerDlg _CAO




CCameraViewerDlg::CCameraViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCameraViewerDlg::IDD, pParent)
	, m_combo_camera_id(0)
	, m_combo_image_size(0)
	, m_combo_fps(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCameraViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_CBIndex(pDX, IDC_COMBO_CAMERA_ID, m_combo_camera_id);
	DDX_CBIndex(pDX, IDC_COMBO_IMAGE_SIZE, m_combo_image_size);
	DDX_CBIndex(pDX, IDC_COMBO_FPS, m_combo_fps);
	DDX_Control(pDX, IDC_COMBO_CAMERA_ID, m_cntl_combo_camera_id);
	DDX_Control(pDX, IDC_COMBO_IMAGE_SIZE, m_cntl_combo_image_size);
	DDX_Control(pDX, IDC_COMBO_FPS, m_cntl_combo_fps);
	DDX_Control(pDX, IDC_BUTTON_VIEW, m_cntl_button_view);
}

BEGIN_MESSAGE_MAP(CCameraViewerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_VIEW, &CCameraViewerDlg::OnBnClickedButtonView)
	ON_BN_CLICKED(IDCANCEL, &CCameraViewerDlg::OnBnClickedCancel)

END_MESSAGE_MAP()


// CCameraViewerDlg bZ[W nh

BOOL CCameraViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

//	ShowWindow(SW_MINIMIZE);

	// TODO: ɒǉ܂B




	// load config
	LoadConfigFile( PATH_CONFIG_FILE );

	// camera ID
	for (int i=0; i<m_max_camera_num; i++) {
		WCHAR  wcbuf[256];
		wsprintf(wcbuf,TEXT("%d"),i);
		m_cntl_combo_camera_id.InsertString(i,wcbuf);
	}
	UpdateData(false);

	// Image size
	for (unsigned int i=0; i<m_size_list.size(); i++) {
		WCHAR  wcbuf[256];
		wsprintf(wcbuf,TEXT("%dx%d"),m_size_list[i].width,m_size_list[i].height);
		m_cntl_combo_image_size.InsertString(i,wcbuf);
	}
	UpdateData(false);

	// fps
	for (unsigned int i=0; i<m_fps_list.size(); i++) {
        CString str;
		str.Format(_T("%.1lf"), m_fps_list[i]);
		m_cntl_combo_fps.InsertString(i,str);
	}
	UpdateData(false);


	m_pCaptureThread = NULL;
	m_pKillThread = NULL;
	m_loopEnable = false;


	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CCameraViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CCameraViewerDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CCameraViewerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


BOOL CCameraViewerDlg::PreTranslateMessage(MSG* pMsg)
{
	// ESCďIȂ悤ɂ
	/*
	if (pMsg->message == WM_KEYDOWN) {
		switch (pMsg->wParam) {
			case VK_RETURN:
			case VK_ESCAPE:
				return TRUE;
			default:
				break;
		}
	}
	*/

	return CDialog::PreTranslateMessage(pMsg);
}


void CCameraViewerDlg::OnBnClickedButtonView()
{
	UpdateData();
	TRACE("m_combo_camera_id=%d \n",m_combo_camera_id);
	TRACE("%d,%d \n",m_size_list[m_combo_image_size].width, m_size_list[m_combo_image_size].height);
	TRACE("fps=%d \n",(int)(m_fps_list[m_combo_fps]));

	int ret = m_capture.Init(m_combo_camera_id);
	if ( ret == -1 ) {
		MessageBox(TEXT("Camera is not available."), TEXT("Error"), MB_ICONERROR | MB_OK);
		return;
	}
	m_capture.SetConfig( m_size_list[m_combo_image_size].width, m_size_list[m_combo_image_size].height, (int)(m_fps_list[m_combo_fps]) );

	// Disable GUIs
	m_cntl_button_view.EnableWindow(false);
	m_cntl_combo_camera_id.EnableWindow(false);
	m_cntl_combo_fps.EnableWindow(false);
	m_cntl_combo_image_size.EnableWindow(false);

	// Run thread
	m_pCaptureThread = AfxBeginThread(CaptureThread,this);
}


// Thread (Parent)
UINT CCameraViewerDlg::CaptureThread(LPVOID pParam)
{
	((CCameraViewerDlg*)pParam)->CaptureThread();
	return 0;
}

 
// Thread (Body)
void CCameraViewerDlg::CaptureThread()
{
	TRACE("CaptureThread : start\n");

	m_loopEnable = true;

	char win[256];
	sprintf( win, "Capture [%d]", m_combo_camera_id );
	cvNamedWindow(win);
 
	IplImage *imgFrame = NULL;
	bool isFull = false;
 
	while (m_loopEnable) {

		imgFrame =  m_capture.QueryFrame();
		cvShowImage( win, imgFrame );
 
		int key = cvWaitKey(1);
		if (key==0x1b) {
			m_loopEnable = false;
		}
		if (key==' ') {
			isFull = !isFull;
			if (isFull) {
				cvuSetWindowFull(win);
			} else {
				cvuSetWindowNormal(win);
			}
		}

		// should be after cvWaitKey()
		void* win_is_active = cvGetWindowHandle(win);
		if ( !win_is_active ) {
			m_loopEnable = false;
		}
	}

	cvDestroyWindow(win);
	m_capture.Release();

	// Enable GUI
	m_cntl_button_view.EnableWindow(true);
	m_cntl_combo_camera_id.EnableWindow(true);
	m_cntl_combo_fps.EnableWindow(true);
	m_cntl_combo_image_size.EnableWindow(true);

	m_pCaptureThread = NULL;

	TRACE("CaptureThread : end\n");
}



// X button or ESC key for main GUI
void CCameraViewerDlg::OnBnClickedCancel()
{
	TRACE("OnBnClickedCancel() is called.\n");

	UpdateData(true);
	SaveConfigFile( PATH_CONFIG_FILE );

	if ( m_pKillThread != NULL ) return;
	if ( m_pCaptureThread != NULL ) {
		m_pKillThread = AfxBeginThread(KillThread,this);
		return;
	}

	OnCancel();
}



// KillThread (Parent)
UINT CCameraViewerDlg::KillThread(LPVOID pParam)
{
	((CCameraViewerDlg*)pParam)->KillThread();
	return 0;
}

// KillThread (Main)
void CCameraViewerDlg::KillThread()
{
	TRACE("KillThread : start\n");
	m_loopEnable = false;

	while ( m_pCaptureThread != NULL ) {
		Sleep(1);
	}
	m_pKillThread = NULL;
	TRACE("Kill Thread : end\n");

	OnCancel();
}



// Load config from file
int CCameraViewerDlg::LoadConfigFile( const char *filename )
{
	TRACE("LoadConfigFile() is called.\n");

	ifstream fin(filename);
	if (!fin) {
		cout << filename << " can not open.\n";
		return -1;
	}
	string word;
	while (fin >> word) {
		if (word=="[MaxCameraNum]") {
			fin >> m_max_camera_num;
		}
		else if (word=="[CameraSelected]") {
			fin >> m_combo_camera_id;
		}
		else if (word=="[ImageSizeList]") {
			int width,height;
			fin >> width >> height;
			m_size_list.push_back(cvSize(width,height));
		}
		else if (word=="[ImageSizeSelected]") {
			fin >> m_combo_image_size;
		}
		else if (word=="[FPS]") {
			double fps;
			fin >> fps;
			m_fps_list.push_back(fps);
		}
		else if (word=="[FPSSelected]") {
			fin >> m_combo_fps;
		}
	}
	UpdateData(false);
	fin.close();
	return 0;
}


// Save config to file
int CCameraViewerDlg::SaveConfigFile( const char * filename = PATH_CONFIG_FILE )
{
	TRACE("SaveConfigFile() is called.\n");
	UpdateData(true);

	ofstream fout(filename);
	if (!fout) {
		return -1;
	}

	fout << "[MaxCameraNum]        " << m_max_camera_num << "\n";
	fout << "[CameraSelected]      " << m_combo_camera_id << "\n";
	for (unsigned int i=0; i<m_size_list.size(); i++) {
		fout << "[ImageSizeList]       " << m_size_list[i].width << " " << m_size_list[i].height << "\n";
	}
	fout << "[ImageSizeSelected]   " << m_combo_image_size << "\n";
	for (unsigned int i=0; i<m_fps_list.size(); i++) {
		fout << "[FPS]                 " << m_fps_list[i] << "\n";
	}
	fout << "[FPSSelected]         " << m_combo_fps << "\n";

	fout.close();
	return 0;
}